/// <reference types="lodash" />
import { EChartsOption, ResizeOpts } from 'echarts';
import { ECharts, init } from 'echarts/core';
import { ECBasicOption } from 'echarts/types/dist/shared';
import { CustomElement } from 'web-utility';
import { ProxyElement } from '../Proxy';
import { ZRElementEventHandler, ZRElementEventName } from '../utility';
export type EChartsElementEventHandler = Partial<Record<`on${Capitalize<ZRElementEventName>}`, ZRElementEventHandler>>;
export interface EChartsElementProps extends ECBasicOption, EChartsElementEventHandler {
    theme?: Parameters<typeof init>[1];
    initOptions?: Omit<Parameters<typeof init>[2], 'renderer'>;
    resizeOptions?: ResizeOpts;
}
export type EChartsElementState = EChartsElementProps & EChartsOption;
export declare abstract class EChartsElement extends ProxyElement<EChartsElementState> implements CustomElement {
    #private;
    core?: ECharts;
    get ready(): Promise<void>;
    get renderer(): string;
    get options(): ECBasicOption;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    setOption: import("../utility").CallBusWrapper<void> & import("../utility").CallBusHandlers;
    setProperty(key: string, value: any): void;
    addEventListener: import("../utility").CallBusWrapper<void> & import("../utility").CallBusHandlers;
    removeEventListener: import("../utility").CallBusWrapper<void> & import("../utility").CallBusHandlers;
    handleResize: import("lodash").DebouncedFunc<() => void>;
}
