var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var _EChartsElement_instances, _EChartsElement_coreDefer, _EChartsElement_init;
import { init } from 'echarts/core';
import { debounce } from 'lodash';
import { parseDOM } from 'web-utility';
import { ProxyElement } from '../Proxy';
import { callBus, unwrapEventHandler, wrapEventHandler } from '../utility';
export class EChartsElement extends ProxyElement {
    get ready() {
        return __classPrivateFieldGet(this, _EChartsElement_coreDefer, "f").promise;
    }
    get renderer() {
        const [_, type] = this.tagName.toLowerCase().split('-');
        return type;
    }
    get options() {
        return this.core.getOption();
    }
    constructor() {
        super();
        _EChartsElement_instances.add(this);
        Object.defineProperty(this, "core", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        _EChartsElement_coreDefer.set(this, Promise.withResolvers());
        Object.defineProperty(this, "setOption", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: callBus((data) => this.core.setOption(data, false, true))
        });
        Object.defineProperty(this, "addEventListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: callBus((name, handler) => {
                this.core
                    .getZr()
                    .on(name, wrapEventHandler.call(this, name, handler));
            })
        });
        Object.defineProperty(this, "removeEventListener", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: callBus((event, handler) => {
                this.core.getZr().off(event, unwrapEventHandler(handler));
            })
        });
        Object.defineProperty(this, "handleResize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: debounce(() => this.core.resize(this.toJSON().resizeOptions))
        });
        this.attachShadow({ mode: 'open' }).append(parseDOM('<div style="height: 100%" />')[0]);
        this.setOption.start();
        this.removeEventListener.start();
        this.addEventListener.start();
    }
    connectedCallback() {
        var _a;
        this.style.display = 'block';
        __classPrivateFieldGet(this, _EChartsElement_instances, "m", _EChartsElement_init).call(this);
        (_a = globalThis.addEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
    }
    disconnectedCallback() {
        var _a, _b;
        (_a = globalThis.removeEventListener) === null || _a === void 0 ? void 0 : _a.call(globalThis, 'resize', this.handleResize);
        (_b = this.core) === null || _b === void 0 ? void 0 : _b.dispose();
    }
    setProperty(key, value) {
        super.setProperty(key, value);
        this.setOption(this.toJSON());
    }
}
_EChartsElement_coreDefer = new WeakMap(), _EChartsElement_instances = new WeakSet(), _EChartsElement_init = function _EChartsElement_init() {
    var _a = this.toJSON(), { theme, initOptions } = _a, props = __rest(_a, ["theme", "initOptions"]);
    this.core = init(this.shadowRoot.firstElementChild, theme, Object.assign(Object.assign({}, initOptions), { renderer: this.renderer }));
    __classPrivateFieldGet(this, _EChartsElement_coreDefer, "f").resolve();
    this.setOption(Object.assign({ grid: {} }, props));
    this.setOption.run();
    this.removeEventListener.run();
    this.addEventListener.run();
};
//# sourceMappingURL=core.js.map