import { ECElementEvent } from 'echarts/core';
export interface QueueTask {
    context: object;
    input: any[];
    output: PromiseWithResolvers<any>;
}
export interface CallBusWrapper<T> {
    (...data: any[]): Promise<T>;
}
export interface CallBusHandlers {
    start: () => Promise<void>;
    run: () => void;
}
export declare function callBus<T>(worker: (...data: any[]) => T): CallBusWrapper<T> & CallBusHandlers;
export declare const EventKeyPattern: RegExp;
export type ZRElementEventName = ECElementEvent['type'];
export type ZRElementEventHandler = (event: ECElementEvent) => boolean | void;
export declare function wrapEventHandler(this: EventTarget, name: string, handler: EventListener): ZRElementEventHandler;
export declare const unwrapEventHandler: (handler: EventListener) => ZRElementEventHandler;
