var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export function callBus(worker) {
    const queue = [Promise.withResolvers()], clutch = Promise.withResolvers();
    function addTask(context, input) {
        const task = {
            context,
            input,
            output: Promise.withResolvers()
        };
        queue.at(-1).resolve(task);
        queue.push(Promise.withResolvers());
        return task;
    }
    const run = () => clutch.resolve();
    function start() {
        return __awaiter(this, void 0, void 0, function* () {
            yield clutch.promise;
            for (let task = queue.shift(); task; task = queue.shift()) {
                const { context, input, output } = yield task.promise;
                try {
                    const data = yield worker.apply(context, input);
                    output.resolve(data);
                }
                catch (error) {
                    output.reject(error);
                }
            }
        });
    }
    return Object.assign(function (...input) {
        return addTask(this, input).output.promise;
    }, { start, run });
}
export const EventKeyPattern = /^on(\w+)/;
const EventHandlerMap = new WeakMap();
export function wrapEventHandler(name, handler) {
    const wrapper = detail => {
        const event = new CustomEvent(name, { detail }), meta = { enumerable: true, value: this };
        Object.defineProperties(event, {
            eventPhase: Object.assign(Object.assign({}, meta), { value: Event.AT_TARGET }),
            srcElement: meta,
            target: meta,
            currentTarget: meta
        });
        handler.call(this, event);
    };
    EventHandlerMap.set(handler, wrapper);
    return wrapper;
}
export const unwrapEventHandler = (handler) => EventHandlerMap.get(handler);
//# sourceMappingURL=utility.js.map